// filter.c @@ tB^֐̍쐬


#include "HU.h" 


void disp_img( int x[][260], int max, int xp, int yp )
{
	int i, j, count ;    
	
	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){

	    count = x[i][j];  count *= 255 / max; 
	   
 		if(count<0) count=0;  if(count>255) count=255;

		SetColor( RGB(count, count, count) );
		SetPixel( i+xp, j+yp );
   }}
}

int get_int_max( int x[][260] )
{
	int	i, j, max=0 ;

	for(j=1;j<=256;j++){ for(i=1;i<=256;i++){

	    if(x[i][j] > max) max = x[i][j];
	}} 
 	printf("\n\n max count = %d ", max);

	return( max );
}


void filter1( int x[][260], int y[][260] )  // Weighted-smoothing
{
	int		i,j;
   
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){

	    y[i][j] = x[i-1][j-1] + x[i][j-1]*2 + x[i+1][j-1]
	 
		        + x[i-1][j]*2 + x[i][j]*4   + x[i+1][j-1]*2
	
				+ x[i-1][j+1] + x[i][j+1]*2 + x[i+1][j+1]   ;
	}} 
 
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){ y[i][j] /= 16; }} 
}

void filter2( int x[][260], int y[][260] )   // Simple smoothing
{ 
	int		i,j;
   
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){

	    y[i][j] = x[i-1][j-1] + x[i][j-1] + x[i+1][j-1]
	 
		        + x[i-1][j]   + x[i][j]   + x[i+1][j-1]
	
				+ x[i-1][j+1] + x[i][j+1] + x[i+1][j+1] ;
	}} 
 
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){ y[i][j] /= 9; }} 
}

void filter3( int x[][260], int y[][260] )   // Vertical Prewitt filter
{
	int		i,j;
   
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){

	    y[i][j] = x[i-1][j-1]*-1 + x[i][j-1]*-1 + x[i+1][j-1]*-1
	 
		        + x[i-1][j]*0    + x[i][j]*0    + x[i+1][j-1]*0
	
				+ x[i-1][j+1]    + x[i][j+1]    + x[i+1][j+1]   ;
	}} 	
}

void filter4( int x[][260], int y[][260] )  // Horizontal Sobel filter
{
	int		i,j;
   
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){

	    y[i][j] = x[i-1][j-1]*-1 + x[i][j-1]*0 + x[i+1][j-1]
	 
		        + x[i-1][j]*-2   + x[i][j]*0   + x[i+1][j-1]*2
	
				+ x[i-1][j+1]*-1 + x[i][j+1]*0 + x[i+1][j+1]   ;
	}} 	
}

void filter5( int x[][260], int y[][260] )   // Unsharp-masking filter
{
	int		i,j;
   
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){

	    y[i][j] = x[i-1][j-1]*0 + x[i][j-1]*-1 + x[i+1][j-1]*0
	 
		        + x[i-1][j]*-1   + x[i][j]*5   + x[i+1][j-1]*-1
	
				+ x[i-1][j+1]*0 + x[i][j+1]*-1 + x[i+1][j+1]*0  ;
	}} 	
}

void laplacian( int x[][260], int y[][260] )   // Laplacian filter
{
	int		i,j;
   
	for(j=2;j<=255;j++){ for(i=2;i<=255;i++){

	    y[i][j] = x[i-1][j-1] + x[i][j-1]  + x[i+1][j-1]
	 
		        + x[i-1][j]   + x[i][j]*-8 + x[i+1][j-1]
	
				+ x[i-1][j+1] + x[i][j+1]  + x[i+1][j+1]  ;
	}} 	
}


void Main(void)
{
	char		a, b, yn, f[100];
	int			i, j, count, maxcount; 
	static int	img[260][260], img2[260][260]; 
	FILE		*fp;
	
	TextWindow(10,10,300,200); Title("filter");
	GraphicWindow(820,820,BK_BLACK);	

START: printf("\n Select original image \n"); ClearWindow();
	
//----------------------- Get image data ----------------------
	GetFileName(f,0);
	printf("\n Display image = \n\n  %s", f); fp=fopen(f,"rb");

	for(j=1;j<=256;j++){for(i=1;i<=256;i++){ 
	      a=fgetc(fp); b=fgetc(fp); img[i][j]=a*256+b;
	}}
	fclose(fp);
//----------------------- Display original image ---------------
    
	maxcount = get_int_max(img);   disp_img(img,maxcount,0,0);

//----------------------- filtering  ---------------------------
	printf("\n\n 3x3 filter "); scanf("%c",&yn);

	filter1( img, img2)  ; disp_img( img2, maxcount, 260*0, 260*1 );
	filter2( img, img2)  ; disp_img( img2, maxcount, 260*1, 260*1 );
	filter3( img, img2)  ; disp_img( img2, maxcount, 260*2, 260*1 );
	filter4( img, img2)  ; disp_img( img2, maxcount, 260*0, 260*2 );
	filter5( img, img2)  ; disp_img( img2, maxcount, 260*1, 260*2 );
	laplacian( img, img2); disp_img( img2, maxcount, 260*2, 260*2 );

//------------------- End -------------------------------
	printf("\n\n Retry? (no:n) ");scanf("%c",&yn);
	if(yn!='n')goto START;
	exit(0);
}